<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Gift Card Codes Auto-Generation
 */

namespace Amasty\GiftCardCodesAutoGeneration\Api\Data;

interface AutoGenerationDataInterface
{
    /**
     * @param int $id
     *
     * @return void
     */
    public function setRecordId(int $id): void;

    /**
     * @return int
     */
    public function getRecordId(): int;

    /**
     * @param int $id
     *
     * @return void
     */
    public function setCodePoolId(int $id): void;

    /**
     * @return int
     */
    public function getCodePoolId(): int;

    /**
     * @param bool $isEnabled
     *
     * @return void
     */
    public function setIsEnabled(bool $isEnabled): void;

    /**
     * @return bool
     */
    public function isEnabled(): bool;

    /**
     * @param int $threshold
     *
     * @return void
     */
    public function setThresholdQty(int $threshold): void;

    /**
     * @return int
     */
    public function getThresholdQty(): int;
}
